#!/bin/sh -efu

a= . install2-init-functions

sysctl_conf_file="$destdir/etc/sysctl.conf"

sed -i '/^kernel\.shm\(max\|all\|mni\)/d' "$sysctl_conf_file" ||:

# sysctl/kernel.txt says "Shared memory segments up to 1Gb are now supported
# in the kernel." (bytes)
shmmax="$(( 1*1024*1024*1024 ))"
# Page size
pagesize="$(getconf PAGESIZE)"
# Physical memory available
totalmem="$(sed -n 's,^MemTotal:[[:space:]]*\([0-9]\+\)[[:space:]]*kB$,\1,p' < /proc/meminfo)"
# Set shared memory limit to RAM/2 but not less than default 8GB (pages)
[ "$(( $totalmem/2 ))" -gt "$(( 8*1024*1024 ))" ] &&
	shmall="$(( $totalmem/2*1024/$pagesize ))" ||
	shmall="$(( 8*1024*1024*1024/$pagesize ))"
# Maximum number of shared memory segments system-wide (default value)
shmmni="4096"

cat <<EOF >>"$sysctl_conf_file"

kernel.shmmax = $shmmax
kernel.shmall = $shmall
kernel.shmmni = $shmmni
EOF
